#include "stdafx.h"

#pragma warning(disable : 4996)

dlldrawopt DllOptions;

void SetupCM()
{

	CHAR path[MAX_PATH];
	HMODULE hm = NULL;

	GetModuleHandleEx(GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS |
		GET_MODULE_HANDLE_EX_FLAG_UNCHANGED_REFCOUNT,
		(LPCWSTR)&SetupCM, &hm);

	GetModuleFileNameA(hm, path, sizeof(path));

	std::string dlltemp = std::string(path);
	std::string ini = "ini";
	dlltemp.replace(dlltemp.end() - 3, dlltemp.end(), ini);

	
	DllOptions.debug = (bool)GetPrivateProfileIntA("General", "Debug", 0, dlltemp.c_str());

	if (DllOptions.debug)
	{
		AllocConsole();
		freopen("CONOUT$", "w", stdout);
		DllOptions.polish_league_cup = (bool)GetPrivateProfileIntA("General", "Disable_PolishLeagueCup", 0, dlltemp.c_str());
		DllOptions.polish_fd_divide_pts = (bool)GetPrivateProfileIntA("General", "Disable_PolishFirstDividePts", 0, dlltemp.c_str());
		DllOptions.polish_competition = (bool)GetPrivateProfileIntA("General", "PolishCompetitions", 0, dlltemp.c_str());

		printf("INI File: %s\n", dlltemp.c_str());
		printf("Disable Polish League Cup: %d\n", DllOptions.polish_league_cup);
		printf("Disable Polish First Divide Pts: %d\n", DllOptions.polish_fd_divide_pts);

	}
	unsigned long OldProt;

	//Disable Polish League Cup
	if (DllOptions.polish_league_cup) {
		uint8_t jump = 0x55;
		VirtualProtect((LPVOID)0x8365e0, 1, PAGE_EXECUTE_READWRITE, &OldProt);
		memcpy((LPVOID)0x8365e0, &jump, 1);
		VirtualProtect((LPVOID)0x8365e0, 1, OldProt, NULL);
	}

	//Disable Polish First Division divide points after league stage;
	if (DllOptions.polish_fd_divide_pts)
	{
		uint8_t onenop = 0x90;
		uint16_t twonops = 0x9090;
		VirtualProtect((LPVOID)0x7c9df9, 1, PAGE_EXECUTE_READWRITE, &OldProt);
		memcpy((LPVOID)0x7c9df9, &onenop, 1);
		VirtualProtect((LPVOID)0x7c9df9, 1, OldProt, NULL);

		VirtualProtect((LPVOID)0x7c9dfd, 2, PAGE_EXECUTE_READWRITE, &OldProt);
		memcpy((LPVOID)0x7c9dfd, &twonops, 2);
		VirtualProtect((LPVOID)0x7c9dfd, 2, OldProt, NULL);

		VirtualProtect((LPVOID)0x7c9e07, 1, PAGE_EXECUTE_READWRITE, &OldProt);
		memcpy((LPVOID)0x7c9e07, &onenop, 1);
		VirtualProtect((LPVOID)0x7c9e07, 1, OldProt, NULL);

		VirtualProtect((LPVOID)0x7c9e0f, 2, PAGE_EXECUTE_READWRITE, &OldProt);
		memcpy((LPVOID)0x7c9e0f, &twonops, 2);
		VirtualProtect((LPVOID)0x7c9e0f, 2, OldProt, NULL);

	}

	if (DllOptions.polish_competition)
	{
		SetupPolishFirst();
		SetupPolishSecond();
	}

}

void SetupPolishSecond()
{
	competition_prt_tb PolSecondDivTable;

	unsigned long OldProt;
	VirtualProtect((LPVOID)polish_second_div_table, sizeof(competition_prt_tb), PAGE_EXECUTE_READWRITE, &OldProt);
	memcpy((void*)&PolSecondDivTable, (void*)polish_second_div_table, sizeof(competition_prt_tb));
	//Changing...
	PolSecondDivTable.comp_addr[2] = reinterpret_cast<uint32_t>(polsec_two);
	PolSecondDivTable.comp_addr[10] = reinterpret_cast<uint32_t>(polsec_three);
	PolSecondDivTable.comp_addr[15] = reinterpret_cast<uint32_t>(polsec_fixtures);
	//PolSecondDivTable.comp_addr[17] = reinterpret_cast<uint32_t>(polsec_A);
	PolSecondDivTable.comp_addr[35] = reinterpret_cast<uint32_t>(polsec_relsub);
	memcpy((void*)polish_second_div_table, (void*)&PolSecondDivTable, sizeof(competition_prt_tb));
	VirtualProtect((LPVOID)polish_second_div_table, sizeof(competition_prt_tb), OldProt, NULL);

	if (DllOptions.debug)
	{
		for (int x = 0; x < 45; x++)
		{
			printf("PolishSecondTablePtr [%d]: 0x%08x\n", x, PolSecondDivTable.comp_addr[x]);
		}
	}

	VirtualProtect((LPVOID)(polish_second_div_call+1), 4, PAGE_EXECUTE_READWRITE, &OldProt);
	uint32_t val = reinterpret_cast<uint32_t>(polsec) - (polish_second_div_call+5);
	memcpy((LPVOID)(polish_second_div_call+1), &val, 4);
	VirtualProtect((LPVOID)(polish_second_div_call+1), 4, OldProt, NULL);
}

void SetupPolishFirst()
{

	unsigned long OldProt;


	competition_prt_tb PolFirstDivTable;

	VirtualProtect((LPVOID)polish_first_div_table, sizeof(competition_prt_tb), PAGE_EXECUTE_READWRITE, &OldProt);
	memcpy((void*)&PolFirstDivTable, (void*)polish_first_div_table, sizeof(competition_prt_tb));
	//Changing...
	PolFirstDivTable.comp_addr[2] = reinterpret_cast<uint32_t>(polfir_two);
	PolFirstDivTable.comp_addr[10] = reinterpret_cast<uint32_t>(polfir_three);
	PolFirstDivTable.comp_addr[15] = reinterpret_cast<uint32_t>(polfir_fixtures);
	PolFirstDivTable.comp_addr[23] = reinterpret_cast<uint32_t>(polfir_six);
	PolFirstDivTable.comp_addr[35] = reinterpret_cast<uint32_t>(polfir_relsub);
	memcpy((void*)polish_first_div_table, (void*)&PolFirstDivTable, sizeof(competition_prt_tb));
	VirtualProtect((LPVOID)polish_first_div_table, sizeof(competition_prt_tb), OldProt, NULL);

	if (DllOptions.debug)
	{
		for (int x = 0; x < 45; x++)
		{
			printf("PolishSecondTablePtr [%d]: 0x%08x\n", x, PolFirstDivTable.comp_addr[x]);
		}
	}

	VirtualProtect((LPVOID)(polish_first_div_call + 1), 4, PAGE_EXECUTE_READWRITE, &OldProt);
	uint32_t val = reinterpret_cast<uint32_t>(polfirst) - (polish_first_div_call + 5);
	memcpy((LPVOID)(polish_first_div_call + 1), &val, 4);
	VirtualProtect((LPVOID)(polish_first_div_call + 1), 4, OldProt, NULL);

	/*
	VirtualProtect((LPVOID)(polfirst_org), 5, PAGE_EXECUTE_READWRITE, &OldProt);
	uint8_t val = 0xE9;
	memcpy((LPVOID)(polfirst_org), &val, 5);
	uint32_t adr = reinterpret_cast<uint32_t>(polfirst)-(polfirst_org+5);
	memcpy((LPVOID)(polfirst_org + 1), &adr, 4);
	VirtualProtect((LPVOID)(polfirst_org), 5, OldProt, NULL);

	VirtualProtect((LPVOID)(polfir_divide_org), 5, PAGE_EXECUTE_READWRITE, &OldProt);
	val = 0xE9;
	memcpy((LPVOID)(polfir_divide_org), &val, 5);
	adr = reinterpret_cast<uint32_t>(polfir_divide) - (polfir_divide_org + 5);
	memcpy((LPVOID)(polfir_divide_org + 1), &adr, 4);
	VirtualProtect((LPVOID)(polfir_divide_org), 5, OldProt, NULL);

	VirtualProtect((LPVOID)(polfir_fixture_org), 5, PAGE_EXECUTE_READWRITE, &OldProt);
	val = 0xE9;
	memcpy((LPVOID)(polfir_fixture_org), &val, 5);
	adr = reinterpret_cast<uint32_t>(polfir_fixtures) - (polfir_fixture_org + 5);
	memcpy((LPVOID)(polfir_fixture_org + 1), &adr, 4);
	VirtualProtect((LPVOID)(polfir_fixture_org), 5, OldProt, NULL);

	VirtualProtect((LPVOID)(polfir_five_org), 5, PAGE_EXECUTE_READWRITE, &OldProt);
	val = 0xE9;
	memcpy((LPVOID)(polfir_five_org), &val, 5);
	adr = reinterpret_cast<uint32_t>(polfir_five) - (polfir_five_org + 5);
	memcpy((LPVOID)(polfir_five_org + 1), &adr, 4);
	VirtualProtect((LPVOID)(polfir_five_org), 5, OldProt, NULL);

	VirtualProtect((LPVOID)(polfir_three_org), 5, PAGE_EXECUTE_READWRITE, &OldProt);
	val = 0xE9;
	memcpy((LPVOID)(polfir_three_org), &val, 5);
	adr = reinterpret_cast<uint32_t>(polfir_three) - (polfir_three_org + 5);
	memcpy((LPVOID)(polfir_three_org + 1), &adr, 4);
	VirtualProtect((LPVOID)(polfir_three_org), 5, OldProt, NULL);

	VirtualProtect((LPVOID)(polfir_two_org), 5, PAGE_EXECUTE_READWRITE, &OldProt);
	val = 0xE9;
	memcpy((LPVOID)(polfir_two_org), &val, 5);
	adr = reinterpret_cast<uint32_t>(polfir_two) - (polfir_two_org + 5);
	memcpy((LPVOID)(polfir_two_org + 1), &adr, 4);
	VirtualProtect((LPVOID)(polfir_two_org), 5, OldProt, NULL);

	VirtualProtect((LPVOID)(polfir_teams_org), 5, PAGE_EXECUTE_READWRITE, &OldProt);
	val = 0xE9;
	memcpy((LPVOID)(polfir_teams_org), &val, 5);
	adr = reinterpret_cast<uint32_t>(polfir_teams) - (polfir_teams_org + 5);
	memcpy((LPVOID)(polfir_teams_org + 1), &adr, 4);
	VirtualProtect((LPVOID)(polfir_teams_org), 5, OldProt, NULL);

	VirtualProtect((LPVOID)(polfir_relsub_org), 5, PAGE_EXECUTE_READWRITE, &OldProt);
	val = 0xE9;
	memcpy((LPVOID)(polfir_relsub_org), &val, 5);
	adr = reinterpret_cast<uint32_t>(polfir_relsub) - (polfir_relsub_org + 5);
	memcpy((LPVOID)(polfir_relsub_org + 1), &adr, 4);
	VirtualProtect((LPVOID)(polfir_relsub_org), 5, OldProt, NULL);

	VirtualProtect((LPVOID)(polfir_lgestage_org), 5, PAGE_EXECUTE_READWRITE, &OldProt);
	val = 0xE9;
	memcpy((LPVOID)(polfir_lgestage_org), &val, 5);
	adr = reinterpret_cast<uint32_t>(polfir_lgestage) - (polfir_lgestage_org + 5);
	memcpy((LPVOID)(polfir_lgestage_org + 1), &adr, 4);
	VirtualProtect((LPVOID)(polfir_lgestage_org), 5, OldProt, NULL);
*/
}

