#pragma once

typedef struct dll_opt
{
	bool polish_league_cup = true;
	bool polish_fd_divide_pts = true;
	bool debug = false;
	bool polish_competition = true;
}dlldrawopt;

typedef struct comptb {
	uint32_t comp_addr[45];
} competition_prt_tb;

const uint32_t polish_first_div_table = 0x0096E360;
const uint32_t polish_second_div_table = 0x0096E4B4;
const uint32_t polish_second_div_call = 0x836587;
const uint32_t polish_first_div_call = 0x836532;

const uint32_t polfirst_org = 0x7c8A80;
const uint32_t polfir_divide_org = 0x7c9B60;
const uint32_t polfir_fixture_org = 0x7c8Df0;
const uint32_t polfir_five_org = 0x7ca030;
const uint32_t polfir_three_org = 0x7c9AD0;
const uint32_t polfir_two_org = 0x7c9740;
const uint32_t polfir_teams_org = 0x7c9450;
const uint32_t polfir_relsub_org = 0x7c9690;
const uint32_t polfir_lgestage_org = 0x7c9900;

typedef struct comp
{
	uint32_t* competitions_off;						//0
	uint32_t competition_db;					//4	
	char* unknown;										//8
	char pad44[16];										//28
	int32_t f28;											//32
	int32_t f32;											//36
	char pad40[4];										//40
	uint32_t f40;											//44
	int32_t f44;											//48
	int32_t f48;											//52
	char pad58[6];										//58
	uint16_t f58;											//60
	uint16_t rounds;									//62
	uint16_t teams;										//64
	uint16_t year;										//66
	char f66;													//67
	char f67;													//68
	char f68;													//69
	char pad73[4];										//73
	char max_bench;										//74
	char max_subs;										//75
	char pad80[5];										//80
	char f80;													//81
	char f81;													//82
	char f82;													//83
	char padx[84];										//167
	uint16_t f167;
	uint16_t f169;										//171
	uint16_t f171;										//173
	uint32_t pad177;									//177
	uint8_t* team_league_dta;									//181
	char pad186[5];										//186
	int32_t f186;											//190
	char promotion;
	char prom_playoff;
	char f193;
	char relegations;
	char f194;
	char f195;
	char f196;
	char f197;
	char f198;
	char f199;												//199
	char pad217[17];									//217
	int16_t f217;											//219
	int16_t f219;											//221
	uint32_t f221;										//225
	char f225;												//226
	char pad237[11];									//237
	uint8_t lastchar;
} comp_s;

static void(*_setup_comp)() =
reinterpret_cast<void(*)()>(0x682200);

static int(*_setup_database)(uint8_t) =
reinterpret_cast<int(*)(uint8_t)>(0x687B10);

static void(*_printcm)(const char*, const char*, uint32_t) =
reinterpret_cast<void(*)(const char*, const char*, uint32_t)>(0x5E8290);

static void(*_leaguecpp)(uint8_t, uint32_t, uint8_t, uint32_t) =
reinterpret_cast<void(*)(uint8_t, uint32_t, uint8_t, uint32_t)>(0x687430);

static uint32_t(*_leagueloadteams)(uint32_t) =
reinterpret_cast<uint32_t(*)(uint32_t)>(0x682F70);

static int(*_xfixtures)() =
reinterpret_cast<int(*)()>(0x6835C0);

static int(*_xtofinanses)() =
reinterpret_cast<int(*)()>(0x683010);

static int(*_xcomp_unk001)() =
reinterpret_cast<int(*)()>(0x6827D0);

static int(*_xcomp_diff)() =
reinterpret_cast<int(*)()>(0x68A850);

static int(*_xcomp_unk002)() =
reinterpret_cast<int(*)()>(0x4A2540);

static int(*_xcreate_league)() =
reinterpret_cast<int(*)()>(0x68B100);

static int(*_xcompstats)(uint32_t) =
reinterpret_cast<int(*)(uint32_t)>(0x49EE70);

static int(*_xcompstats2)(uint32_t) =
reinterpret_cast<int(*)(uint32_t)>(0x4A2540);

static void*(*_xqsort)(size_t size) =
reinterpret_cast<void*(*)(size_t)>(0x945333);

static void*(*_xmalloc)(size_t size) =
reinterpret_cast<void*(*)(size_t)>(0x944e46);

static void*(*_xnew)(size_t size) =
reinterpret_cast<void*(*)(size_t)>(0x944CF1);

static int(*xsub_521E60)() =
reinterpret_cast<int(*)()>(0x521E60);

static int(*xsub_521EB0)() =
reinterpret_cast<int(*)()>(0x521EB0);

static int(*ToSetDateFixture)() =
reinterpret_cast<int(*)()>(0x68A160);

static int(*Set_Fixture)() =
reinterpret_cast<int(*)()>(0x68A1C0);

static int(*xsub_687970)() =
reinterpret_cast<int(*)()>(0x687970);

static int(*xsub_9452CA)() =
reinterpret_cast<int(*)()>(0x9452CA);

static int(*xsub_4A1C50)() =
reinterpret_cast<int(*)()>(0x4A1C50);

static int(*xsub_79CEE0)() =
reinterpret_cast<int(*)()>(0x79CEE0);

static int(*xsub_68AA80)() =
reinterpret_cast<int(*)()>(0x68AA80);

static int(*xsub_945501)() =
reinterpret_cast<int(*)()>(0x945501);

static int(*xsub_6826D0)() =
reinterpret_cast<int(*)()>(0x6826D0);

static int(*xsub_522E00)() =
reinterpret_cast<int(*)()>(0x522E00);

static int(*xsub_51C800)() =
reinterpret_cast<int(*)()>(0x51C800);

static int(*xsub_868C50)() =
reinterpret_cast<int(*)()>(0x868C50);

static int(*xsub_869480)() =
reinterpret_cast<int(*)()>(0x869480);

static int(*xsub_86BDD0)() =
reinterpret_cast<int(*)()>(0x86BDD0);

static int(*xsub_86A1C0)() =
reinterpret_cast<int(*)()>(0x86A1C0);

static int(*xsub_4AFBD0)() =
reinterpret_cast<int(*)()>(0x4AFBD0);

static int(*xsub_6830B0)() =
reinterpret_cast<int(*)()>(0x6830B0);

static int(*xsub_6831A0)() =
reinterpret_cast<int(*)()>(0x6831A0);

static int(*xsub_68AB70)() =
reinterpret_cast<int(*)()>(0x68AB70);

static int(*xsub_4B07D0)() =
reinterpret_cast<int(*)()>(0x4B07D0);

int32_t(*_subrelcall)(int8_t, uint32_t, uint32_t, uint32_t);

uint32_t clubs_db_ptr = reinterpret_cast<uint32_t*>(0xAE23B4)[0];

uint32_t _sub_AE235C = reinterpret_cast<uint32_t*>(0xAE235C)[0];

uint32_t _sub_9CF85C = reinterpret_cast<uint32_t*>(0x9CF85C)[0];

uint32_t varc = 0x0019CD30;

static const char* str_err = "Error";


extern "C"
{
	void SetupCM();
	void SetupPolishSecond();
	void SetupPolishFirst();
}