#include "stdafx.h"
#include "pol_firdiv.h"

const char* seh_txt = "SEH Error for function";
const char* seh_err = "Error SEH";
const char* str_err_pfsix = "Polish First Division Six";
const char* str_err_fd_div1 = "Polish First Division Divide 1";
const char* str_err_pf_three = "Polish First Division Three";
const char* str_err_pf_five = "Polish First Division Five";
const char* str_err_pf_two = "Polish First Division Two";
const char* str_err_first = "Polish First Division Main";
const char* str_err_pffix = "Polish First Division Fixtures";
const char* str_err_pfstage = "Polish First Division League Stage";
const char* str_err_pfteams = "Polish First Division Teams";

_declspec(naked) int seh_main()
{
	_asm
	{
		push	ebp
		mov		ebp, esp
		push 0
		push seh_err
		push seh_txt
		call _printcm
		add esp,12
		leave
		ret
	}
}

_declspec(naked) int loc_7CA450()
{
	_asm
	{
		mov     eax, [esp + 4]
		push    esi
		mov     ecx, [eax]
		mov     edx, [ecx + 0x60]
		mov     ecx, 0x9CF814
		mov			ecx, [ecx]
		mov     esi, [edx]
		mov     edx, [esp + 0xC]
		cmp     esi, ecx
		mov     edx, [edx]
		setnz   al
		mov     edx, [edx + 0x60]
		inc     eax
		movsx   eax, al
		mov     esi, [edx]
		cmp     esi, ecx
		pop     esi
		setnz   cl
		inc     ecx
		movsx   edx, cl
		sub     eax, edx
		ret
	}
}

_declspec(naked) int polfir_six()
{
	_asm
	{
		sub     esp, 0x200
		push    ebx
		push    edi
		mov     edi, ecx
		xor     ebx, ebx
		cmp			[edi + 8], ebx
		jnz     short loc_7CA256

		//ERR
		push		0
		push		str_err_pfsix
		push		str_err
		call		_printcm
		add			esp, 12
		pop     edi
		pop     ebx
		add     esp, 200h
		retn

	loc_7CA256 :
		mov     ecx, [edi + 0xEE]
		push    esi
		push    0x4B07D0
		push    4
		push    0x10
		push    ecx
		call    _xqsort
		add     esp, 0x10
		xor     esi, esi

	loc_7CA271 :
		mov     edx, [edi + 0xEE]
		mov     ecx, [edi + 8]
		push    esi
		mov     eax, [edx + ebx]
		push    eax
		call    _xcompstats2
		inc     esi
		add     ebx, 4
		cmp     si, 0x10
		jl      loc_7CA271

		pop     esi
		pop     edi
		pop     ebx
		add     esp, 0x200
		retn
	}
}


#define setfix( z,  weekd,  year,  month,  day, rnd) _asm{\
	_asm	mov     ax, [edi + 40h]\
	_asm	push    0	\
	_asm	push    eax	\
	_asm	push    z	\
	_asm	push    weekd \
	_asm	push    year	\
	_asm	push    month	\
	_asm	push    day	 \
	_asm	push    rnd \
	_asm	push    esi \
	_asm	call    ToSetDateFixture \
	_asm	push    0 \
	_asm	push    0FFFFFFFFh	\
	_asm	push    0FFFFFFFFh	\
	_asm	push    0FFFFFFFFh	\
	_asm	push    0	\
	_asm	push    rnd \
	_asm	push    esi \
	_asm	call    Set_Fixture \
	_asm	add     esp, 40h}

// Setup fixtures
_declspec(naked) int polfir_fixtures()
{
	_asm
	{
		mov     al, [esp + 4]
		sub     esp, 0x200
		cmp     al, 1
		push    esi
		push    edi
		mov     edi, ecx
		jge     loc_7C910E

		mov     ecx, [esp + 0x208 + 0x10]
		test    ecx, ecx
		jz      loc_7C8E17

		mov     dword ptr[ecx], 1

	loc_7C8E17:
		mov     ecx, [esp + 0x208 + 8]
		push    0x38E
		movsx   dx, al
		mov     eax, [esp + 0x20C + 0xc]
		add     edx, 0x420
		mov     word ptr[ecx], 0xE		//; ; FixNumber ? ? ?
		mov			[eax], dx
		call    _xmalloc
		mov     esi, eax
		add     esp, 4
		test    esi, esi
		jnz     loc_7C8E7D

		jmp     loc_7C917E
		
	loc_7C8E7D :
		setfix(1, 5, 0, 6, 0x16, 0);
		setfix(1, 5, 0, 6, 0x1d, 1);
		setfix(1, 5, 0, 7, 5, 2);
		setfix(1, 5, 0, 7, 0xc, 3);
		setfix(1, 5, 0, 7, 0x13, 4);
		setfix(1, 5, 0, 7, 0x1a, 5);
		setfix(1, 5, 0, 8, 9, 6);
		setfix(1, 5, 0, 8, 0x10, 7);
		setfix(1, 5, 0, 8, 0x17, 8);
		setfix(1, 5, 0, 8, 0x1e, 9);
		setfix(1, 5, 0, 9, 0xe, 10);
		setfix(1, 5, 0, 9, 0x15, 11);
		setfix(1, 5, 0, 9, 0x1c, 12);
		setfix(1, 5, 0, 10, 3, 13);
		//add     esp, 40h
		mov     eax, esi
		pop     edi
		pop     esi
		add     esp, 200h
		retn    10h

	loc_7C910E :
		jnz     loc_7C91B1

		mov     eax, [esp + 208h + 0x10]
		test    eax, eax
		jz      short loc_7C9125

	loc_7C9125 :
		mov     ecx, [esp + 208h + 8]
		mov     edx, [esp + 208h + 12]
		push    38Eh
		mov     word ptr[ecx], 0Eh
		mov     word ptr[edx], 0
		call    _xmalloc
		mov     esi, eax
		add     esp, 4
		test    esi, esi
		jnz     loc_7C91BE

	loc_7C917E :			//ERR
		push		0
		push		str_err_pffix
		push		str_err
		call		_printcm

	loc_7C91B1 :
		pop     edi
		xor     eax, eax
		pop     esi
		add     esp, 200h
		ret     10h

	loc_7C91BE :
		mov     cx, [edi + 40h]
		push    0
		push    ecx
		push    1
		push    5
		push    0
		push    0Ah
		push    11h
		push    0
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    0
		push    esi
		call    Set_Fixture
		mov     dx, [edi + 40h]
		add     esp, 40h
		push    0
		push    edx
		push    1
		push    5
		push    0
		push    0Ah
		push    18h
		push    1
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    1
		push    esi
		call    Set_Fixture
		mov     ax, [edi + 40h]
		add     esp, 40h
		push    0
		push    eax
		push    1
		push    5
		push    1
		push    2
		push    2
		push    2
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    2
		push    esi
		call    Set_Fixture
		mov     cx, [edi + 40h]
		add     esp, 40h
		push    0
		push    ecx
		push    1
		push    5
		push    1
		push    2
		push    9
		push    3
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    3
		push    esi
		call    Set_Fixture
		add     esp, 40h
		push    0
		mov     dx, [edi + 40h]
		push    edx
		push    2
		push    2
		push    1
		push    2
		push    10h
		push    4
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    4
		push    esi
		call    Set_Fixture
		mov     ax, [edi + 40h]
		add     esp, 40h
		push    0
		push    eax
		push    1
		push    5
		push    1
		push    2
		push    17h
		push    5
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    5
		push    esi
		call    Set_Fixture
		mov     cx, [edi + 40h]
		add     esp, 40h
		push    0
		push    ecx
		push    1
		push    5
		push    1
		push    2
		push    1Eh
		push    6
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    6
		push    esi
		call    Set_Fixture
		mov     dx, [edi + 40h]
		add     esp, 40h
		push    0
		push    edx
		push    1
		push    5
		push    1
		push    3
		push    6
		push    7
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    7
		push    esi
		call    Set_Fixture
		mov     ax, [edi + 40h]
		add     esp, 40h
		push    0
		push    eax
		push    1
		push    5
		push    1
		push    3
		push    0Dh
		push    8
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    8
		push    esi
		call    Set_Fixture
		mov     cx, [edi + 40h]
		add     esp, 40h
		push    0
		push    ecx
		push    1
		push    5
		push    1
		push    3
		push    14h
		push    9
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    9
		push    esi
		call    Set_Fixture
		mov     dx, [edi + 40h]
		add     esp, 40h
		push    0
		push    edx
		push    1
		push    5
		push    1
		push    3
		push    1Bh
		push    0Ah
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    0Ah
		push    esi
		call    Set_Fixture
		mov     ax, [edi + 40h]
		add     esp, 40h
		push    0
		push    eax
		push    1
		push    5
		push    1
		push    4
		push    4
		push    0Bh
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    0Bh
		push    esi
		call    Set_Fixture
		mov     cx, [edi + 40h]
		add     esp, 40h
		push    0
		push    ecx
		push    1
		push    5
		push    1
		push    4
		push    0Bh
		push    0Ch
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    0Ch
		push    esi
		call    Set_Fixture
		mov     dx, [edi + 40h]
		add     esp, 40h
		push    0
		push    edx
		push    1
		push    5
		push    1
		push    4
		push    12h
		push    0Dh
		push    esi
		call    ToSetDateFixture
		push    0
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0FFFFFFFFh
		push    0
		push    0Dh
		push    esi
		call    Set_Fixture
		add     esp, 40h
		mov     eax, esi
		pop     edi
		pop     esi
		add     esp, 200h
		retn    10h

	}
}


// Fuction checked stage of league (group / second stage) divide pts etc
_declspec(naked) int polfir_divide()
{
	_asm
	{
		push		0xffffffff
		push		seh_main
		mov			eax, fs: 0
		push		eax
		mov			fs : 0, esp
		sub     esp, 0x214
		push    ebx
		push    ebp
		push    esi
		push    edi
		xor     bl, bl
		mov     esi, ecx
		push    0x40
		mov			[esp + 0x234 - 0x21C], bl
		mov			[esp + 0x234 - 0x21B], bl
		mov			[esp + 0x234 - 0x21A], 0					//Play-off rel
		mov			[esp + 0x234 - 0x219], 3					//Relegation
		call    _xmalloc
		mov     ebp, eax
		xor     edi, edi
		add     esp, 4
		cmp     ebp, edi
		jnz     loc_7C9C08

		//ERR
		push		0
		push		str_err_fd_div1
		push		str_err
		call		_printcm
		jmp     loc_7CA017

	loc_7C9C08 :
		xor     eax, eax

	loc_7C9C0A :
		mov     ecx, [esi + 0xB1]
		add     eax, 0x3B
		movsx   edx, bl
		mov     ecx, [eax + ecx - 0x3B]
		inc     bl
		mov			[ebp + edx * 4 + 0], ecx
		mov     edx, [esi + 0xC]
		mov     ecx, [edx]
		mov     edx, [ecx + 0xB1]
		movsx   ecx, bl
		mov     edx, [edx + eax - 0x3B]
		inc     bl
		mov			[ebp + ecx * 4 + 0], edx
		mov     ecx, 0x9CF814
		mov			ecx, [ecx]
		lea     edx, [ecx + ecx * 2]
		lea     edx, [edx + edx * 8]
		shl     edx, 2
		sub     edx, ecx
		mov     ecx, 0xAE23D0
		mov			ecx, [ecx]
		add     edx, ecx
		mov     ecx, [esi + 0xB1]
		mov     ecx, [eax + ecx - 0x3B]
		mov			[ecx + 0x60], edx
		mov     ecx, 0x9CF814
		mov			ecx, [ecx]
		lea     edx, [ecx + ecx * 2]
		lea     edx, [edx + edx * 8]
		shl     edx, 2
		sub     edx, ecx
		mov     ecx, 0xAE23D0
		mov			ecx, [ecx]
		add     edx, ecx
		mov     ecx, [esi + 0xC]
		cmp     eax, 0ECh
		mov     ecx, [ecx]
		mov     ecx, [ecx + 0xB1]
		mov     ecx, [ecx + eax - 0x3B]
		mov			[ecx + 0x60], edx
		jl      loc_7C9C0A

		mov     eax, 0ECh

	loc_7C9C99 :
		mov     edx, [esi + 0B1h]
		add     eax, 3Bh
		movsx   ecx, bl
		mov     edx, [eax + edx - 3Bh]
		inc     bl
		mov			[ebp + ecx * 4 + 0], edx
		mov     ecx, [esi + 0Ch]
		mov     edx, [ecx]
		mov     ecx, [edx + 0B1h]
		movsx   edx, bl
		mov     ecx, [ecx + eax - 3Bh]
		inc     bl
		mov			[ebp + edx * 4 + 0], ecx
		mov     ecx, 0x9CF818
		mov			ecx, [ecx]
		lea     edx, [ecx + ecx * 2]
		lea     edx, [edx + edx * 8]
		shl     edx, 2
		sub     edx, ecx
		mov     ecx, 0xAE23D0
		mov			ecx,[ecx]
		add     edx, ecx
		mov     ecx, [esi + 0B1h]
		mov     ecx, [eax + ecx - 3Bh]
		mov			[ecx + 60h], edx
		mov     ecx, 0x9CF818
		mov			ecx, [ecx]
		lea     edx, [ecx + ecx * 2]
		lea     edx, [edx + edx * 8]
		shl     edx, 2
		sub     edx, ecx
		mov     ecx, 0xAE23D0
		mov			ecx, [ecx]
		add     edx, ecx
		mov     ecx, [esi + 0Ch]
		cmp     eax, 1D8h
		mov     ecx, [ecx]
		mov     ecx, [ecx + 0B1h]
		mov     ecx, [ecx + eax - 3Bh]
		mov			[ecx + 60h], edx
		jl      loc_7C9C99

		push    0EEh
		call		_xnew
		mov     ebx, eax
		add     esp, 4
		mov			[esp + 230h - 0x220], ebx
		cmp     ebx, edi
		mov			[esp + 230h - 4], edi
		jz      loc_7C9D99

		push    1
		push    11170h
		mov     ecx, esi
		call    _leagueloadteams
		mov     dx, [esi + 40h]
		push    eax
		push    0Eh
		push    3
		push    edi
		push    1
		push    14h
		push    edi
		push    1
		lea     eax, [esp + 254h - 0x21C]
		push    edx
		mov     dl, [esi + 0C4h]
		lea     ecx, [esi + 0C5h]
		push    eax
		mov     al, [esi + 0C3h]
		push    ecx
		mov     cl, [esi + 0C2h]
		push    edx
		mov     edx, [esi + 4]
		push    eax
		push    ecx
		push    edi
		push    edi
		push    edx
		push    2
		push    ebp
		push    10h
		push    esi
		mov     ecx, ebx
		call    _xcreate_league
		mov     ebx, eax
		jmp     short loc_7C9D9B

	loc_7C9D99 :
		xor     ebx, ebx

	loc_7C9D9B :
		mov     eax, [esi + 0Ch]
		or			edi, 0FFFFFFFFh
		mov			[esp + 230h - 4], edi
		mov			[eax + 4], ebx
		xor     eax, eax
		cmp			[ebx + 3Eh], ax
		mov			[esp + 230h - 0x220], eax
		jle     loc_7C9EA5

		mov			[esp + 230h - 0x210], eax

	loc_7C9DBF :
		mov     edi, [esp + 230h - 0x210]
		mov     ecx, [ebx + 0B1h]
		add     edi, ecx
		push    0
		mov     ecx, [edi]
		push    ecx
		mov     ecx, esi
		call    xsub_68AB70
		mov     ecx, eax
		test    ecx, ecx
		jnz     short loc_7C9DF5

		mov     edx, [edi]
		push    eax
		mov     eax, [esi + 0Ch]
		push    edx
		mov     ecx, [eax]
		call    xsub_68AB70
		mov     ecx, eax
		test    ecx, ecx
		jz      loc_7C9E82

	loc_7C9DF5 :
		movsx   eax, word ptr[ecx + 19h]
		//inc     eax
		cdq
		sub     eax, edx
		//sar     eax, 1
		mov			[edi + 19h], ax
		movsx   eax, word ptr[ecx + 27h]
		//inc     eax
		cdq
		sub     eax, edx
		mov     dx, [edi + 19h]
		//sar     eax, 1
		sub     dx, ax
		mov			[edi + 27h], ax
		mov			[edi + 35h], dx
		mov     al, [ecx + 12h]
		mov			[edi + 12h], al
		mov     dl, [ecx + 20h]
		mov			[edi + 20h], dl
		mov     al, [ecx + 2Eh]
		mov			[edi + 2Eh], al
		mov     dl, [ecx + 13h]
		mov			[edi + 13h], dl
		mov     al, [ecx + 21h]
		mov			[edi + 21h], al
		mov     dl, [ecx + 2Fh]
		mov			[edi + 2Fh], dl
		mov     al, [ecx + 14h]
		mov			[edi + 14h], al
		mov     dl, [ecx + 22h]
		mov			[edi + 22h], dl
		mov     al, [ecx + 30h]
		mov			[edi + 30h], al
		mov     dx, [ecx + 15h]
		mov			[edi + 15h], dx
		mov     ax, [ecx + 23h]
		mov			[edi + 23h], ax
		mov     dx, [ecx + 31h]
		mov			[edi + 31h], dx
		mov     ax, [ecx + 17h]
		mov			[edi + 17h], ax
		mov     dx, [ecx + 25h]
		mov			[edi + 25h], dx
		mov     ax, [ecx + 33h]
		mov			[edi + 33h], ax

	loc_7C9E82 :
		mov     eax, [esp + 230h - 0x220]
		mov     edi, [esp + 230h - 0x210]
		movsx   ecx, word ptr[ebx + 3Eh]
		inc     eax
		add     edi, 3Bh
		cmp     eax, ecx
		mov			[esp + 230h - 0x220], eax
		mov			[esp + 230h - 0x210], edi
		jl      loc_7C9DBF

		or edi, 0FFFFFFFFh

	loc_7C9EA5 :
		mov     edx, [esi + 0Ch]
		push    0
		mov     eax, [edx + 4]
		//push		eax
		//mov			eax, loc_7CA450
		mov     dword ptr[eax + 0xA3], 0x7CA450
		//pop			eax
		mov     ecx, [esi + 0Ch]
		mov     ecx, [ecx + 4]
		call    _xcomp_unk001
		mov     edx, [esi]
		lea     eax, [esp + 230h - 0x214]
		push    0
		lea     ecx, [esp + 234h - 0x218]
		push    eax
		push    ecx
		push    1
		mov     ecx, esi
		mov     dword ptr[esi + 30h], 1
		call    dword ptr[edx + 3Ch]
		push    0EEh
		mov     ebx, eax
		call		_xnew
		add     esp, 4
		mov			[esp + 230h - 0x220], eax
		test    eax, eax
		mov			[esp + 230h - 4], 1
		jz      loc_7C9F55

		mov     edx, [esp + 230h - 0x214]
		mov     cx, [esi + 40h]
		push    2
		push    0
		push    edi
		push    3
		push    0
		push    1
		push    14h
		push    edx
		push    1
		push    ecx
		lea     edx, [esi + 0BEh]
		lea     ecx, [esi + 0C5h]
		push    edx
		mov     dl, [esi + 0C4h]
		push    ecx
		mov     cl, [esi + 0C3h]
		push    edx
		mov     dl, [esi + 0C2h]
		push    ecx
		mov     ecx, [esp + 268h - 0x218]
		push    edx
		mov     edx, [esi + 4]
		push    ecx
		push    ebx
		push    edx
		push    2
		push    ebp
		push    8
		push    esi
		mov     ecx, eax
		call    _xcreate_league
		jmp     loc_7C9F57

	loc_7C9F55 :
		xor     eax, eax

	loc_7C9F57 :
		test    eax, eax
		mov			[esp + 230h - 4], edi
		jz      loc_7C9F6A

		mov     edx, [eax]
		push    1
		mov     ecx, eax
		call    dword ptr[edx]

	loc_7C9F6A:
		push    ebx
		call    xsub_9452CA
		mov     eax, [esi]
		add     esp, 4
		lea     ecx, [esp + 230h - 0x214]
		lea     edx, [esp + 230h - 0x218]
		push    0
		push    ecx
		push    edx
		push    1
		mov     ecx, esi
		call    dword ptr[eax + 3Ch]
		push    0EEh
		mov     ebx, eax
		call		_xnew
		add     esp, 4
		mov			[esp + 230h - 0x220], eax
		test    eax, eax
		mov			[esp + 230h - 4], 2
		jz      loc_7CA002

		mov     ecx, [esp + 230h - 0x214]
		mov     dx, [esi + 40h]
		push    2
		push    0
		push    edi
		push    3
		push    0
		push    1
		push    14h
		push    ecx
		push    1
		push    edx
		lea     ecx, [esi + 0BEh]
		lea     edx, [esi + 0C5h]
		push    ecx
		mov     cl, [esi + 0C4h]
		push    edx
		mov     dl, [esi + 0C3h]
		push    ecx
		mov     cl, [esi + 0C2h]
		push    edx
		mov     edx, [esp + 268h - 0x218]
		push    ecx
		mov     ecx, [esi + 4]
		push    edx
		push    ebx
		push    ecx
		add     ebp, 20h
		push    2
		push    ebp
		push    8
		push    esi
		mov     ecx, eax
		call    _xcreate_league
		jmp     loc_7CA004

	loc_7CA002 :
		xor     eax, eax

	loc_7CA004 :
		test    eax, eax
		mov			[esp + 230h - 4], edi
		jz      loc_7CA017

		mov     edx, [eax]
		push    1
		mov     ecx, eax
		call    dword ptr[edx]

	loc_7CA017:
		mov     ecx, [esp + 230h - 0xc]
		pop     edi
		pop     esi
		pop     ebp
		pop     ebx
		mov			fs:0 , ecx
		add     esp, 220h
		ret
	}
}

// Wrapper to polish first divide after group stage
_declspec(naked) int polfir_three()
{
	_asm
	{
		mov     edx, [ecx + 0x2C]
		mov     eax, [ecx + 0x30]
		sub     esp, 0x200
		dec     edx
		cmp     eax, edx
		jl      loc_7C9B4B

		//ERR
		push		0
		push		str_err_pf_three
		push		str_err
		call		_printcm
		add     esp, 0x200
		ret

	loc_7C9B4B :
		inc     eax
		mov			[ecx + 0x30], eax
		dec     eax
		jnz     loc_7C9B57

		call		polfir_divide

	loc_7C9B57 :
		add     esp, 0x200
		ret

	}
}

// Fuction gets team from lower division to second. Why here??? Possible rest from older cm versions???
_declspec(naked) int polfir_five()
{
	_asm
	{
		sub     esp, 0x208
		mov     eax, 0xADADFC
		mov			eax, [eax]
		push    ebx
		mov     ebx, ecx
		push    ebp
		mov     ecx, 0x9CF85C
		mov			ecx, [ecx]
		push    esi
		push    edi
		xor     esi, esi
		mov     edx, [eax + ecx * 4]
		mov     eax, 0xAE235C
		mov			eax, [eax]
		mov			[esp + 0x218 - 0x208], edx
		lea     ecx, [eax * 4]
		push    ecx
		call    _xmalloc
		mov     ebp, eax
		add     esp, 4
		test    ebp, ebp
		jnz     loc_7CA0D2

		//ERR
		push		0
		push		str_err_pf_five
		push		str_err
		call		_printcm
		pop     edi
		pop     esi
		pop     ebp
		pop     ebx
		add     esp, 0x208
		ret

	loc_7CA0D2 :
		mov     ecx, 0xAE235C
		mov			ecx, [ecx]
		mov     eax, 0xAE23B4
		mov			eax, [eax]
		xor     edx, edx
		test    ecx, ecx
		jle     loc_7CA1C8

	loc_7CA0E7 :
		mov     ecx, [eax + 0x53]			// Team Division ???
		test    ecx, ecx
		jz      loc_7CA11B

		mov     ecx, [ecx]
		mov     edi, 0x9CF430						// 0x94 comp_nr???
		mov			edi, [edi]					
		cmp     ecx, edi
		jnz     loc_7CA11B

		mov     ecx, [eax + 0x57]
		test    ecx, ecx
		jz      short loc_7CA11B

		mov     ecx, [ecx]
		mov     edi, 0x9CF868
		mov			edi, [edi]
		cmp     ecx, edi
		jnz     short loc_7CA11B

		movsx   ecx, si
		inc     esi
		mov			[ebp + ecx * 4 + 0], eax
		mov     ecx, [eax + 0x57]
		mov			[eax + 0x5B], ecx

	loc_7CA11B :
		mov     ecx, [eax + 0x57]
		inc     edx
		mov			[esp + 0x218 - 0x204], ecx
		mov     ecx, 0xAE235C
		mov			ecx, [ecx]
		add     eax, 245h
		cmp     edx, ecx
		jl      short loc_7CA0E7

		cmp     si, 4							// 4 from lower div
		jl      loc_7CA1C8

		push    4
		push    esi
		push    ebp
		call    xsub_4AFBD0				// ToRandom
		add     esp, 0xC
		mov     esi, ebp
		mov     edi, 4

	loc_7CA14F:
		mov     eax, 0x9CF85C
		mov			eax, [eax]
		push    1
		lea     ecx, [eax + eax * 2]
		lea     edx, [ecx + ecx * 8]
		mov     ecx, 0xAE23D0
		mov			ecx, [ecx]
		shl     edx, 2
		sub     edx, eax
		mov     eax, [esi]
		add     edx, ecx
		mov     ecx, ebx
		push    edx
		push    eax
		call    xsub_6830B0
		add     esi, 4
		dec     edi
		jnz     loc_7CA14F

		mov     edx, [esp + 0x218 - 0x208]
		movsx   edi, word ptr[edx + 0x3E]
		movsx   ecx, byte ptr[edx + 0xC1]
		mov     esi, edi
		sub     esi, ecx
		cmp     esi, edi
		jge     loc_7CA1C8

		jmp     loc_7CA197

	loc_7CA193 :
		mov     edx, [esp + 0x218 - 0x208]

	loc_7CA197 :
		mov     eax, 0x9CF868
		mov			eax, [eax]
		push    1
		lea     ecx, [eax + eax * 2]
		lea     ecx, [ecx + ecx * 8]
		shl     ecx, 2
		sub     ecx, eax
		mov     eax, 0xAE23D0
		mov			eax, [eax]
		add     ecx, eax
		push    ecx
		push    esi
		mov     ecx, edx
		call    xsub_6826D0
		mov     edx, [eax]
		mov     ecx, ebx
		push    edx
		call    xsub_6831A0
		inc     esi
		cmp     esi, edi
		jl      loc_7CA193

	loc_7CA1C8 :
		push    ebp
		call    xsub_9452CA
		add     esp, 4
		pop     edi
		pop     esi
		pop     ebp
		pop     ebx
		add     esp, 0x208
		retn

	}
}

//?
_declspec(naked) int polfir_lgestage()
{
	_asm
	{
		mov     eax, fs : 0
		push		0xFFFFFFFF
		push		seh_main
		push		eax
		mov			fs : 0, esp
		sub     esp, 0x40C
		lea     edx, [esp + 0x418 - 0x418]
		push    ebx
		push    ebp
		push    esi
		mov     esi, ecx
		xor     ebp, ebp
		push    edi
		mov     eax, [esi]
		lea     ecx, [esp + 0x428 - 0x414]
		push    ebp
		push    ecx
		push    edx
		push    ebp
		mov     ecx, esi
		call    dword ptr[eax + 0x3C]
		mov     ebx, eax
		movsx   eax, word ptr[esi + 0x3E]
		shl     eax, 2
		push    eax
		call    _xmalloc
		mov     edi, eax
		add     esp, 4
		cmp     edi, ebp
		jnz     loc_7C9980

		jmp     loc_7C9A74

	loc_7C9980 :
		xor     ecx, ecx
		cmp			[esi + 0x3E], bp
		jle     loc_7C99AE

		mov     edx, 0x20
		mov     eax, edi
		sub     edx, edi

	loc_7C9991 :
		mov     ebp, [esi + 0xEE]
		add     eax, 4
		add     ebp, edx
		inc     ecx
		mov     ebp, [eax + ebp - 4]
		mov			[eax - 4], ebp
		movsx   ebp, word ptr[esi + 0x3E]
		cmp     ecx, ebp
		jl      loc_7C9991

		xor     ebp, ebp

	loc_7C99AE : 
		push    0xEE
		call		_xnew
		add     esp, 4
		mov			[esp + 0x428 - 0x410], eax
		cmp     eax, ebp
		mov			[esp + 0x428 - 4], ebp
		jz      loc_7C9A28

		mov     dx, [esi + 0xD9]
		mov     cl, [esi + 0x51]
		push    2
		push    ebp
		push    0xFFFFFFFF
		push    edx
		mov     edx, [esp + 0x438 - 0x414]
		push    ebp
		push    1
		push    ecx
		mov     cx, [esi + 0x40]
		push    edx
		push    ebp
		push    ecx
		lea     edx, [esi + 0xBE]
		lea     ecx, [esi + 0xC5]
		push    edx
		mov     dl, [esi + 0xC4]
		push    ecx
		mov     cl, [esi + 0xC3]
		push    edx
		mov     dl, [esi + 0xC2]
		push    ecx
		mov     ecx, [esp + 0x460 - 0x418]
		push    edx
		mov     edx, [esi + 4]
		push    ecx
		mov     cx, [esi + 0x3E]
		push    ebx
		push    edx
		push    2
		push    edi
		push    ecx
		push    esi
		mov     ecx, eax
		call    _xcreate_league
		jmp     loc_7C9A2A

	loc_7C9A28 :
		xor     eax, eax

	loc_7C9A2A :
		mov     edx, [esi + 0xC]
		mov			[esp + 0x428 - 4], 0xFFFFFFFF
		mov			[edx], eax
		mov     eax, [esi + 0xC]
		cmp			[eax], ebp
		jnz     loc_7C9AA5

	loc_7C9A74 :
		push		0
		push		str_err_pfstage
		push		str_err
		call		_printcm
		jmp     short loc_7C9AB7

	loc_7C9AA5 : 
		push    edi
		call    xsub_9452CA
		push    ebx; lpMem
		call    xsub_9452CA
		add     esp, 8
		mov			[esi + 0x30], ebp


	loc_7C9AB7 :
		mov     ecx, [esp + 0x428 - 0xC]
		pop     edi
		pop     esi
		pop     ebp
		pop     ebx
		mov     fs : 0, ecx
		add     esp, 418h
		retn
	}
}

// Main Fuction called on new season (or load)...
_declspec(naked) int polfir_two()
{
	_asm
	{
		sub     esp, 0x200
		push    esi
		mov     esi, ecx
		push    edi
		xor     edi, edi
		mov     eax, [esi]
		push    1
		mov			[esi + 0x4C], edi
		call    dword ptr[eax + 0xB0]
		mov     ecx, esi
		call    polfir_five
		push    edi; lpMem
		mov     ecx, esi
		call    xsub_687970
		mov     eax, [esi + 0xBA]
		cmp     eax, edi
		jz      loc_7C9781

		push    eax
		call    xsub_9452CA
		add     esp, 4
		mov			[esi + 0xBA], edi

	loc_7C9781 :
		mov     ecx, [esi + 8]
		cmp     ecx, edi
		jz      loc_7C978F

		push    1
		call    xsub_4A1C50

	loc_7C978F :
		mov     edx, [esi]
		inc     word ptr[esi + 0x40]
		mov     ecx, esi
		call    dword ptr[edx + 0x8C]
		test    eax, eax
		jnz     loc_7C97D3

		jmp     loc_7C9882 //error

	loc_7C97D3 :
		mov     ecx, esi
		call    polfir_teams
		test    eax, eax
		jnz     loc_7C980E

		jmp     loc_7C9883

	loc_7C980E :
		mov     ecx, esi
		call    _xfixtures
		test    eax, eax
		jnz     loc_7C9849

		jmp     loc_7C9883

	loc_7C9849 : 
		push    edi
		mov     ecx, esi
		call    _xcomp_unk001
		test    eax, eax
		jnz     loc_7C98BA

		jmp     loc_7C9883

	loc_7C9882 :
		push    eax

	loc_7C9883:			//ERROR
		push		0
		push		str_err_pf_two
		push		str_err
		call		_printcm
		pop     edi
		pop     esi
		add     esp, 0x200
		ret

	loc_7C98BA :
		mov     ecx, esi
		call    polfir_lgestage
		mov     ecx, 0xADADFC
		mov			ecx, [ecx]
		mov     edx, 0x9CF85C
		mov			edx, [edx]
		mov     ecx, [ecx + edx * 4]
		mov     eax, [ecx]
		call    dword ptr[eax + 8]
		mov     edx, [esi]
		mov     ecx, esi
		call    dword ptr[edx + 0x5C]
		mov     ecx, esi
		call    xsub_68AA80
		mov     eax, [esi + 4]
		mov     ecx, 0xB74340
		mov			ecx, [ecx]
		push    eax
		call    xsub_79CEE0
		pop     edi
		pop     esi
		add     esp, 0x200
		ret
	}
}

// Setup Relegation/Promotions/Substitute/Squad Numbers/Playoffs etc...
_declspec(naked) int polfir_relsub()
{
	_asm
	{
		push    esi
		mov     esi, ecx
		mov     ecx, 2
		xor			eax, eax
		mov     dl, 4
		mov			[esi + 0x3C], cx				//; Rounds
		mov     byte ptr[esi + 0xC2], 3
		mov     byte ptr[esi + 0xC3], 1
		mov			[esi + 0xC4], cl
		mov			[esi + 0xAB], ax
		mov			[esi + 0xDB], ax
		mov     byte ptr[esi + 0x42], 1
		mov			[esi + 0xC5], dl
		mov     byte ptr[esi + 0xC6], 1
		mov			[esi + 0xC7], cl
		mov			[esi + 0xBE], 4			//4 teams prom ? ? ?
		mov     edx, [esi]
		mov			[esi + 0xBF], al
		mov			[esi + 0xC0], al
		mov			[esi + 0xC1], al
		mov     dword ptr[esi + 0x1C], 0xFFFFFFFF; 
		mov     ecx, 0x9CF85C						// Ptr to relegation league
		mov			ecx, [ecx]
		mov			[esi + 0x52], 2					// Squad Numbers
		push    eax
		mov			[esi + 0x20], ecx
		lea     eax, [esi + 0x3A]
		lea     ecx, [esi + 0xA9]
		push    eax
		push    ecx
		push    0xFFFFFFFF
		mov     ecx, esi
		mov     byte ptr[esi + 0x49], 7
		mov     byte ptr[esi + 0x4A], 3
		mov     word ptr[esi + 0xD9], 8			//; Diff // not be
		call    dword ptr[edx + 0x3C]				// Call polfir_fixtures
		mov			[esi + 0xBA], eax						// Fixtures ptr...
		mov     eax, 1
		pop     esi
		ret
	}
}

//Setup teams load from database
_declspec(naked) int polfir_teams()
{
	_asm
	{
		sub     esp, 0x210
		push    ebp
		push    esi
		mov     esi, ecx
		mov     eax, 8		//teams
		push    0x1d8
		mov			[esp + 0x21C - 0x210], 1
		mov			[esi + 0x3E], ax
		mov			[esp + 0x21C - 0x20F], 4
		mov			[esp + 0x21C - 0x20E], 5
		mov			[esp + 0x21C - 0x20D], al
		mov			[esp + 0x21C - 0x20C], 9
		mov			[esp + 0x21C - 0x20B], 0xC
		mov			[esp + 0x21C - 0x20A], 0xD
		mov			[esp + 0x21C - 0x209], 0x10
		mov			[esp + 0x21C - 0x208], 2
		mov			[esp + 0x21C - 0x207], 3
		mov			[esp + 0x21C - 0x206], 6
		mov			[esp + 0x21C - 0x205], 7
		mov			[esp + 0x21C - 0x204], 0xA
		mov			[esp + 0x21C - 0x203], 0xB
		mov			[esp + 0x21C - 0x202], 0xE
		mov			[esp + 0x21C - 0x201], 0xF
		call    _xmalloc
		xor     ebp, ebp
		add     esp, 4
		cmp     eax, ebp
		mov			[esi + 0xB1], eax
		jnz     loc_7C94FB

		jmp feerror

	loc_7C94FB :
		mov     eax, [esi + 0xEE]
		cmp     eax, ebp
		jz      loc_7C950E

		push    eax
		call    xsub_9452CA
		add     esp, 4

	loc_7C950E:
		push    4
		push    0x10
		call    xsub_945501
		add     esp, 8
		cmp     eax, ebp
		mov			[esi + 0xEE], eax
		jnz     loc_7C958B

	feerror:
		push		0
		push		str_err_pfteams
		push		str_err
		call		_printcm
		xor     eax, eax
		pop     esi
		pop     ebp
		add     esp, 0x210
		ret

	loc_7C958B :
		mov     eax, 0xAE235C
		mov			eax, [eax]
		push    edi
		mov     edi, 0xAE23B4 //Teams in database
		mov			edi, [edi]
		cmp     eax, ebp
		jle     loc_7C9644

		push    ebx

	loc_7C95A0 : 
		mov     eax, [edi + 0x57]
		test    eax, eax
		jz      loc_7C962C

		mov     edx, [eax]
		mov     eax, 0x9CF858
		mov			eax, [eax]
		cmp     edx, eax
		jnz     loc_7C962C

		mov     eax, [edi + 0x5B]
		mov     ecx, [esi + 4]
		mov     dl, [edi + 0x5F]
		cmp     eax, ecx
		jz      loc_7C95E2

		cmp     dl, 1
		jz      loc_7C95DF

		cmp     dl, 2
		jz      loc_7C95DF

		cmp     dl, 3
		jnz     loc_7C95D6

		mov     dl, 0xE
		jmp     loc_7C95E2

	loc_7C95D6 :
		cmp     dl, 4
		jnz     loc_7C95E2

		mov     dl, 0xD
		jmp     loc_7C95E2

	loc_7C95DF :
		add     dl, 0xE

	loc_7C95E2 :
		xor     al, al

	loc_7C95E4 :
		movsx   ecx, al
		cmp			[esp + ecx + 0x220 - 0x210], dl
		jnz     loc_7C95F9

		mov     ebx, [esi + 0xEE]
		cmp     dword ptr[ebx + ecx * 4], 0
		jz      loc_7C95FF

	loc_7C95F9 :
		inc     al
		cmp     al, 0x10
		jl      loc_7C95E4


	loc_7C95FF :
		cmp     al, 0x10
		jnz     loc_7C961E

		mov     ecx, [esi + 0xEE]
		xor			al, al

	loc_7C960B :
		movsx   edx, al
		cmp     dword ptr[ecx + edx * 4], 0
		jz      loc_7C961C

		inc     al
		cmp     al, 0x10
		jl      loc_7C960B

		jmp     loc_7C962C

	loc_7C961C :
		cmp     al, 0x10
	loc_7C961E :
		jge     loc_7C962C

		mov     ecx, [esi + 0xEE]
		movsx   eax, al
		mov			[ecx + eax * 4], edi

	loc_7C962C :
		mov     eax, 0xAE235C
		mov			eax, [eax]
		inc     ebp
		movsx   edx, bp
		add     edi, 0x245
		cmp     edx, eax
		jl      loc_7C95A0		//; Competitions in Database

		pop			ebx

	loc_7C9644 :
		xor     edi, edi
		cmp			[esi + 0x3E], di
		jle     loc_7C966C

		loc_7C964C :					//; LOAD TEAMS
		mov     ecx, [esi + 0xEE]
		push    0
		movsx   eax, di
		push    0
		mov     edx, [ecx + eax * 4]
		mov     ecx, esi
		push    edx
		push    edi
		call    _leaguecpp
		inc     edi
		cmp     di, [esi + 0x3E]
		jl      loc_7C964C

	loc_7C966C :
		push    0
		push    0x7A120
		mov     ecx, esi
		call    _xtofinanses
		pop     edi
		pop     esi
		mov     eax, 1
		pop     ebp
		add     esp, 0x210
		ret
	}
}

const char* str_polfirts = "fun polfirst start...";

// First main setup function called on Start New Game...(?)
_declspec(naked) int polfirst()
{
	_asm
	{
		push		0xffffffff
		push		seh_main
		mov			eax, fs: 0
		push		eax
		mov			fs: 0, esp
		sub     esp, 0x208
		push    ebx
		push    esi
		mov     esi, ecx
		mov			[esp + 0x21C - 0x210], esi
		call    _setup_comp
		mov     ecx, [esp + 0x21C + 8]
		mov     ax, [esp + 0x21C + 4]
		xor			ebx, ebx
		mov			[esi + 4], ecx // Database Competition Addr.
		push    1
		mov     ecx, esi
		mov			[esp + 0x220 - 4], ebx
		mov     dword ptr[esi], 0x0096E360
		mov			[esi + 0xEE], ebx
		mov			[esi + 0x40], ax		//year
		mov     byte ptr[esi + 0x50], 0x1F
		call    _setup_database											//; saving or creating.tmp
		test    eax, eax
		jz      loc_7C8B03

		cmp     dword ptr[esi + 0x30], 1
		jl      loc_7C8D10

		mov     edx, [esi + 0xC]
		mov     eax, [edx + 4]
		//push		eax
		//mov			eax, loc_7CA450
		mov     dword ptr[eax + 0xA3], 0x7CA450		// to pol_divide
		//pop			eax
		jmp     loc_7C8D10

	loc_7C8B03 :
		or			eax, 0xFFFFFFFF
		push    8
		mov			[esi + 0x44], al
		mov			[esi + 0x30], eax
		mov     dword ptr[esi + 0x2C], 2
		call    _xmalloc
		add     esp, 4
		mov     ecx, esi
		mov			[esi + 0xC], eax
		call    polfir_relsub
		test    eax, eax
		jnz     loc_7C8B5B

		jmp			loc_7C8C6B

	loc_7C8B5B :
		mov     ecx, esi
		call    polfir_teams
		test    eax, eax
		jnz     loc_7C8B95

		jmp			loc_7C8C6A

	loc_7C8B95 :
		mov     ecx, esi
		call    _xfixtures
		test    eax, eax
		jnz     loc_7C8BD0

		jmp     loc_7C8C6B

	loc_7C8BD0 : 
		push    ebx
		mov     ecx, esi
		call    _xcomp_unk001
		test    eax, eax
		jnz     loc_7C8C09

		jmp     loc_7C8C6B

	loc_7C8C09 : 
		push    0x5CE
		call		_xnew
		add     esp, 4
		mov			[esp + 0x21C - 0x214], eax
		cmp     eax, ebx
		mov     byte ptr[esp + 0x21C - 4], 1
		jz      loc_7C8C30

		push    esi
		mov     ecx, eax
		call    _xcompstats
		jmp     loc_7C8C32

	loc_7C8C30 :
		xor     eax, eax

	loc_7C8C32 :
		cmp     eax, ebx
		mov     byte ptr[esp + 0x21C - 4], bl
		mov			[esi + 8], eax
		jnz     loc_7C8C9B

	loc_7C8C6A :
		push    edx

	loc_7C8C6B :	// ERROR
		push		0
		push		str_err_first
		push		str_err
		call		_printcm
		jmp     loc_7C8D10

	loc_7C8C9B :
		mov     ecx, esi
		call    polfir_lgestage
		cmp			[esi + 8], ebx
		jnz     loc_7C8CD7

		jmp     short loc_7C8C6B

	loc_7C8CD7 :
		mov			ecx, [esi + 0xEE]
		push    edi
		push    0x4B07D0; //int(__cdecl *)(const void *, const void *)
		push    4
		push    0x10
		push    ecx
		call    _xqsort
		add     esp, 0x10
		xor     edi, edi

	loc_7C8CF2 :
		mov     edx, [esi + 0xEE]
		mov     ecx, [esi + 8]
		push    edi
		mov     eax, [ebx + edx]
		push    eax
		call    _xcomp_unk002
		inc     edi
		add     ebx, 4
		cmp     di, 0x10
		jl      loc_7C8CF2

		pop     edi

	loc_7C8D10 :
		mov     ecx, [esp + 0x21C - 0xC]
		mov     eax, esi
		pop     esi
		pop     ebx
		mov			fs: 0, ecx
		add     esp, 0x214
		ret     8
	}
}